# $Id: MySQLTie.pm,v 1.4 2004/03/18 00:31:41 reed Exp $

package Modules::Log::TieLibs::MySQLTie;

use DBI;

my $dbh;

sub DoWriteSQL {
	print "DoWriteSQL called";
	my $line = $_[0];
	my $sth = $dbh->prepare("INSERT INTO defender_log VALUES ('" . gmtime() . "','$line','')");
	$sth->execute() or print "$DBI::errstr\n";
	$sth->finish();
}

sub WRITE {
	my $r = shift;
	my($buf,$len,$offset) = @_;
	DoWriteSQL($buf);
}

sub PRINTF {
        shift;
        my $fmt = shift;
        DoWriteSQL(sprintf($fmt, @_)."\n");
}


sub TIEHANDLE {
	print "TIEHANDLE called\n";
	my $class = shift;
	my $fh = local *FH;
	bless \$fh, $class;
	my ($db_host,$db_database,$db_user,$db_pass) = @_;
	my $data_source = "DBI:mysql:$db_database:$db_host";
	print "Logging into mysql database $db_host ($db_database) for MySQL logging...";
	$dbh = DBI->connect($data_source, $db_user, $db_pass) or print "$DBI::errstr\n";
	print "Done!\n";
	$| = 1;
	DoWriteSQL("test test!");
	\$class;
}

sub READLINE {
	return 1;
}

sub PRINT {
	print "PRINT handler called\n";
	my $class = shift;
	DoWriteSQL(join('', @_));
	1;

}

sub OPEN {
	print "OPEN handler called\n";
	# always succeeds
	return 1;
}

1;
